# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from google_chat_ros/Card.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import google_chat_ros.msg

class Card(genpy.Message):
  _md5sum = "bb2b7c6880601ea58b79855bc615f5d1"
  _type = "google_chat_ros/Card"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """google_chat_ros/CardHeader header # The header of the card
google_chat_ros/Section[] sections # Sections are separated by a line divider
google_chat_ros/CardAction[] card_actions # The actions of this card
string name # Name of the card

================================================================================
MSG: google_chat_ros/CardHeader
string title
string subtitle
bool image_style_circular # The image's type, makes border
string image_url
string image_filepath # The image in the card header

================================================================================
MSG: google_chat_ros/Section
string header # The header of the section
google_chat_ros/WidgetMarkup[] widgets

================================================================================
MSG: google_chat_ros/WidgetMarkup
google_chat_ros/Button[] buttons
string text_paragraph # Display a text paragraph in this widget
google_chat_ros/Image image # Display an image in this widget
google_chat_ros/KeyValue key_value # Display a key value item in this widget

================================================================================
MSG: google_chat_ros/Button
### FIELD DATA CAN BE ONLY ONE OF THE TEXT BUTTON OR IMAGE BUTTON ###
# A button with text and onclick action
string text_button_name 
google_chat_ros/OnClick text_button_on_click
# An image button with an onclick action
string image_button_name
google_chat_ros/OnClick image_button_on_click
string icon # see https://developers.google.com/chat/api/reference/rest/v1/cards#icon
string original_icon_url # Original icon image's url
string original_icon_filepath # Original icon

================================================================================
MSG: google_chat_ros/OnClick
### FIELD DATA CAN BE ONLY ONE OF THE FOLLOWING ###
google_chat_ros/FormAction action # A form action will be triggered by this onclick if specified
string open_link_url # A link that opens a new window

================================================================================
MSG: google_chat_ros/FormAction
# The form action data associated with an interactive card that was clicked. Only populated for CARD_CLICKED events.
string action_method_name
google_chat_ros/ActionParameter[] parameters

================================================================================
MSG: google_chat_ros/ActionParameter
string key
string value

================================================================================
MSG: google_chat_ros/Image
string image_url
string localpath # If you want to upload new image on google drive, please set this element, not image_uri.
google_chat_ros/OnClick on_click
float64 aspect_ratio # The aspect ratio of this image (width/height). If unset, the server fills it by prefetching the image

================================================================================
MSG: google_chat_ros/KeyValue
string top_label # The text of the top label
string content # The text of the content. Always required
bool content_multiline # If the content should be multiline
string bottom_label # The text of the bottom label
google_chat_ros/OnClick on_click
string icon # see https://developers.google.com/chat/api/reference/rest/v1/cards#icon
string original_icon_url # Original icon image's url
string original_icon_localpath # If you want to upload new image on google drive, please set this element, not original_icon_url.
google_chat_ros/Button button # A button that can be clicked to trigger an action

================================================================================
MSG: google_chat_ros/CardAction
string action_label # The label used to be displayed in the action menu item
google_chat_ros/OnClick on_click
"""
  __slots__ = ['header','sections','card_actions','name']
  _slot_types = ['google_chat_ros/CardHeader','google_chat_ros/Section[]','google_chat_ros/CardAction[]','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,sections,card_actions,name

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Card, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = google_chat_ros.msg.CardHeader()
      if self.sections is None:
        self.sections = []
      if self.card_actions is None:
        self.card_actions = []
      if self.name is None:
        self.name = ''
    else:
      self.header = google_chat_ros.msg.CardHeader()
      self.sections = []
      self.card_actions = []
      self.name = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.header.title
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.header.subtitle
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.header.image_style_circular
      buff.write(_get_struct_B().pack(_x))
      _x = self.header.image_url
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.header.image_filepath
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.sections)
      buff.write(_struct_I.pack(length))
      for val1 in self.sections:
        _x = val1.header
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.widgets)
        buff.write(_struct_I.pack(length))
        for val2 in val1.widgets:
          length = len(val2.buttons)
          buff.write(_struct_I.pack(length))
          for val3 in val2.buttons:
            _x = val3.text_button_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _v1 = val3.text_button_on_click
            _v2 = _v1.action
            _x = _v2.action_method_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            length = len(_v2.parameters)
            buff.write(_struct_I.pack(length))
            for val6 in _v2.parameters:
              _x = val6.key
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val6.value
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v1.open_link_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val3.image_button_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _v3 = val3.image_button_on_click
            _v4 = _v3.action
            _x = _v4.action_method_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            length = len(_v4.parameters)
            buff.write(_struct_I.pack(length))
            for val6 in _v4.parameters:
              _x = val6.key
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val6.value
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v3.open_link_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val3.icon
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val3.original_icon_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val3.original_icon_filepath
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.text_paragraph
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _v5 = val2.image
          _x = _v5.image_url
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v5.localpath
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _v6 = _v5.on_click
          _v7 = _v6.action
          _x = _v7.action_method_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          length = len(_v7.parameters)
          buff.write(_struct_I.pack(length))
          for val6 in _v7.parameters:
            _x = val6.key
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val6.value
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v6.open_link_url
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v5.aspect_ratio
          buff.write(_get_struct_d().pack(_x))
          _v8 = val2.key_value
          _x = _v8.top_label
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v8.content
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v8.content_multiline
          buff.write(_get_struct_B().pack(_x))
          _x = _v8.bottom_label
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _v9 = _v8.on_click
          _v10 = _v9.action
          _x = _v10.action_method_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          length = len(_v10.parameters)
          buff.write(_struct_I.pack(length))
          for val6 in _v10.parameters:
            _x = val6.key
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val6.value
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v9.open_link_url
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v8.icon
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v8.original_icon_url
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v8.original_icon_localpath
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _v11 = _v8.button
          _x = _v11.text_button_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _v12 = _v11.text_button_on_click
          _v13 = _v12.action
          _x = _v13.action_method_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          length = len(_v13.parameters)
          buff.write(_struct_I.pack(length))
          for val7 in _v13.parameters:
            _x = val7.key
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val7.value
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v12.open_link_url
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v11.image_button_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _v14 = _v11.image_button_on_click
          _v15 = _v14.action
          _x = _v15.action_method_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          length = len(_v15.parameters)
          buff.write(_struct_I.pack(length))
          for val7 in _v15.parameters:
            _x = val7.key
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val7.value
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v14.open_link_url
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v11.icon
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v11.original_icon_url
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v11.original_icon_filepath
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.card_actions)
      buff.write(_struct_I.pack(length))
      for val1 in self.card_actions:
        _x = val1.action_label
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v16 = val1.on_click
        _v17 = _v16.action
        _x = _v17.action_method_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(_v17.parameters)
        buff.write(_struct_I.pack(length))
        for val4 in _v17.parameters:
          _x = val4.key
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val4.value
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v16.open_link_url
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = google_chat_ros.msg.CardHeader()
      if self.sections is None:
        self.sections = None
      if self.card_actions is None:
        self.card_actions = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.title = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.title = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.subtitle = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.subtitle = str[start:end]
      start = end
      end += 1
      (self.header.image_style_circular,) = _get_struct_B().unpack(str[start:end])
      self.header.image_style_circular = bool(self.header.image_style_circular)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.image_url = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.image_url = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.image_filepath = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.image_filepath = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.sections = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.Section()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.header = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.header = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.widgets = []
        for i in range(0, length):
          val2 = google_chat_ros.msg.WidgetMarkup()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.buttons = []
          for i in range(0, length):
            val3 = google_chat_ros.msg.Button()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.text_button_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val3.text_button_name = str[start:end]
            _v18 = val3.text_button_on_click
            _v19 = _v18.action
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v19.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v19.action_method_name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v19.parameters = []
            for i in range(0, length):
              val6 = google_chat_ros.msg.ActionParameter()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val6.key = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val6.key = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val6.value = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val6.value = str[start:end]
              _v19.parameters.append(val6)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v18.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v18.open_link_url = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.image_button_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val3.image_button_name = str[start:end]
            _v20 = val3.image_button_on_click
            _v21 = _v20.action
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v21.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v21.action_method_name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v21.parameters = []
            for i in range(0, length):
              val6 = google_chat_ros.msg.ActionParameter()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val6.key = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val6.key = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val6.value = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val6.value = str[start:end]
              _v21.parameters.append(val6)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v20.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v20.open_link_url = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.icon = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val3.icon = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.original_icon_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val3.original_icon_url = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.original_icon_filepath = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val3.original_icon_filepath = str[start:end]
            val2.buttons.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.text_paragraph = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.text_paragraph = str[start:end]
          _v22 = val2.image
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v22.image_url = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v22.image_url = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v22.localpath = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v22.localpath = str[start:end]
          _v23 = _v22.on_click
          _v24 = _v23.action
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v24.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v24.action_method_name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v24.parameters = []
          for i in range(0, length):
            val6 = google_chat_ros.msg.ActionParameter()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val6.key = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val6.key = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val6.value = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val6.value = str[start:end]
            _v24.parameters.append(val6)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v23.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v23.open_link_url = str[start:end]
          start = end
          end += 8
          (_v22.aspect_ratio,) = _get_struct_d().unpack(str[start:end])
          _v25 = val2.key_value
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v25.top_label = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v25.top_label = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v25.content = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v25.content = str[start:end]
          start = end
          end += 1
          (_v25.content_multiline,) = _get_struct_B().unpack(str[start:end])
          _v25.content_multiline = bool(_v25.content_multiline)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v25.bottom_label = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v25.bottom_label = str[start:end]
          _v26 = _v25.on_click
          _v27 = _v26.action
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v27.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v27.action_method_name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v27.parameters = []
          for i in range(0, length):
            val6 = google_chat_ros.msg.ActionParameter()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val6.key = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val6.key = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val6.value = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val6.value = str[start:end]
            _v27.parameters.append(val6)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v26.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v26.open_link_url = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v25.icon = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v25.icon = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v25.original_icon_url = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v25.original_icon_url = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v25.original_icon_localpath = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v25.original_icon_localpath = str[start:end]
          _v28 = _v25.button
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v28.text_button_name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v28.text_button_name = str[start:end]
          _v29 = _v28.text_button_on_click
          _v30 = _v29.action
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v30.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v30.action_method_name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v30.parameters = []
          for i in range(0, length):
            val7 = google_chat_ros.msg.ActionParameter()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val7.key = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val7.key = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val7.value = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val7.value = str[start:end]
            _v30.parameters.append(val7)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v29.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v29.open_link_url = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v28.image_button_name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v28.image_button_name = str[start:end]
          _v31 = _v28.image_button_on_click
          _v32 = _v31.action
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v32.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v32.action_method_name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v32.parameters = []
          for i in range(0, length):
            val7 = google_chat_ros.msg.ActionParameter()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val7.key = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val7.key = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val7.value = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val7.value = str[start:end]
            _v32.parameters.append(val7)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v31.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v31.open_link_url = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v28.icon = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v28.icon = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v28.original_icon_url = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v28.original_icon_url = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v28.original_icon_filepath = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v28.original_icon_filepath = str[start:end]
          val1.widgets.append(val2)
        self.sections.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.card_actions = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.CardAction()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.action_label = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.action_label = str[start:end]
        _v33 = val1.on_click
        _v34 = _v33.action
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v34.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v34.action_method_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v34.parameters = []
        for i in range(0, length):
          val4 = google_chat_ros.msg.ActionParameter()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val4.key = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val4.key = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val4.value = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val4.value = str[start:end]
          _v34.parameters.append(val4)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v33.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v33.open_link_url = str[start:end]
        self.card_actions.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.header.title
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.header.subtitle
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.header.image_style_circular
      buff.write(_get_struct_B().pack(_x))
      _x = self.header.image_url
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.header.image_filepath
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.sections)
      buff.write(_struct_I.pack(length))
      for val1 in self.sections:
        _x = val1.header
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.widgets)
        buff.write(_struct_I.pack(length))
        for val2 in val1.widgets:
          length = len(val2.buttons)
          buff.write(_struct_I.pack(length))
          for val3 in val2.buttons:
            _x = val3.text_button_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _v35 = val3.text_button_on_click
            _v36 = _v35.action
            _x = _v36.action_method_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            length = len(_v36.parameters)
            buff.write(_struct_I.pack(length))
            for val6 in _v36.parameters:
              _x = val6.key
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val6.value
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v35.open_link_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val3.image_button_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _v37 = val3.image_button_on_click
            _v38 = _v37.action
            _x = _v38.action_method_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            length = len(_v38.parameters)
            buff.write(_struct_I.pack(length))
            for val6 in _v38.parameters:
              _x = val6.key
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val6.value
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v37.open_link_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val3.icon
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val3.original_icon_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val3.original_icon_filepath
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.text_paragraph
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _v39 = val2.image
          _x = _v39.image_url
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v39.localpath
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _v40 = _v39.on_click
          _v41 = _v40.action
          _x = _v41.action_method_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          length = len(_v41.parameters)
          buff.write(_struct_I.pack(length))
          for val6 in _v41.parameters:
            _x = val6.key
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val6.value
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v40.open_link_url
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v39.aspect_ratio
          buff.write(_get_struct_d().pack(_x))
          _v42 = val2.key_value
          _x = _v42.top_label
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v42.content
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v42.content_multiline
          buff.write(_get_struct_B().pack(_x))
          _x = _v42.bottom_label
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _v43 = _v42.on_click
          _v44 = _v43.action
          _x = _v44.action_method_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          length = len(_v44.parameters)
          buff.write(_struct_I.pack(length))
          for val6 in _v44.parameters:
            _x = val6.key
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val6.value
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v43.open_link_url
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v42.icon
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v42.original_icon_url
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v42.original_icon_localpath
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _v45 = _v42.button
          _x = _v45.text_button_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _v46 = _v45.text_button_on_click
          _v47 = _v46.action
          _x = _v47.action_method_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          length = len(_v47.parameters)
          buff.write(_struct_I.pack(length))
          for val7 in _v47.parameters:
            _x = val7.key
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val7.value
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v46.open_link_url
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v45.image_button_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _v48 = _v45.image_button_on_click
          _v49 = _v48.action
          _x = _v49.action_method_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          length = len(_v49.parameters)
          buff.write(_struct_I.pack(length))
          for val7 in _v49.parameters:
            _x = val7.key
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val7.value
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v48.open_link_url
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v45.icon
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v45.original_icon_url
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v45.original_icon_filepath
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.card_actions)
      buff.write(_struct_I.pack(length))
      for val1 in self.card_actions:
        _x = val1.action_label
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v50 = val1.on_click
        _v51 = _v50.action
        _x = _v51.action_method_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(_v51.parameters)
        buff.write(_struct_I.pack(length))
        for val4 in _v51.parameters:
          _x = val4.key
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val4.value
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v50.open_link_url
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = google_chat_ros.msg.CardHeader()
      if self.sections is None:
        self.sections = None
      if self.card_actions is None:
        self.card_actions = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.title = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.title = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.subtitle = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.subtitle = str[start:end]
      start = end
      end += 1
      (self.header.image_style_circular,) = _get_struct_B().unpack(str[start:end])
      self.header.image_style_circular = bool(self.header.image_style_circular)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.image_url = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.image_url = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.image_filepath = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.image_filepath = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.sections = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.Section()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.header = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.header = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.widgets = []
        for i in range(0, length):
          val2 = google_chat_ros.msg.WidgetMarkup()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.buttons = []
          for i in range(0, length):
            val3 = google_chat_ros.msg.Button()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.text_button_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val3.text_button_name = str[start:end]
            _v52 = val3.text_button_on_click
            _v53 = _v52.action
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v53.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v53.action_method_name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v53.parameters = []
            for i in range(0, length):
              val6 = google_chat_ros.msg.ActionParameter()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val6.key = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val6.key = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val6.value = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val6.value = str[start:end]
              _v53.parameters.append(val6)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v52.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v52.open_link_url = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.image_button_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val3.image_button_name = str[start:end]
            _v54 = val3.image_button_on_click
            _v55 = _v54.action
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v55.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v55.action_method_name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v55.parameters = []
            for i in range(0, length):
              val6 = google_chat_ros.msg.ActionParameter()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val6.key = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val6.key = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val6.value = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val6.value = str[start:end]
              _v55.parameters.append(val6)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v54.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v54.open_link_url = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.icon = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val3.icon = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.original_icon_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val3.original_icon_url = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.original_icon_filepath = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val3.original_icon_filepath = str[start:end]
            val2.buttons.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.text_paragraph = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.text_paragraph = str[start:end]
          _v56 = val2.image
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v56.image_url = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v56.image_url = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v56.localpath = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v56.localpath = str[start:end]
          _v57 = _v56.on_click
          _v58 = _v57.action
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v58.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v58.action_method_name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v58.parameters = []
          for i in range(0, length):
            val6 = google_chat_ros.msg.ActionParameter()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val6.key = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val6.key = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val6.value = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val6.value = str[start:end]
            _v58.parameters.append(val6)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v57.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v57.open_link_url = str[start:end]
          start = end
          end += 8
          (_v56.aspect_ratio,) = _get_struct_d().unpack(str[start:end])
          _v59 = val2.key_value
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v59.top_label = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v59.top_label = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v59.content = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v59.content = str[start:end]
          start = end
          end += 1
          (_v59.content_multiline,) = _get_struct_B().unpack(str[start:end])
          _v59.content_multiline = bool(_v59.content_multiline)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v59.bottom_label = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v59.bottom_label = str[start:end]
          _v60 = _v59.on_click
          _v61 = _v60.action
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v61.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v61.action_method_name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v61.parameters = []
          for i in range(0, length):
            val6 = google_chat_ros.msg.ActionParameter()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val6.key = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val6.key = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val6.value = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val6.value = str[start:end]
            _v61.parameters.append(val6)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v60.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v60.open_link_url = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v59.icon = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v59.icon = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v59.original_icon_url = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v59.original_icon_url = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v59.original_icon_localpath = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v59.original_icon_localpath = str[start:end]
          _v62 = _v59.button
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v62.text_button_name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v62.text_button_name = str[start:end]
          _v63 = _v62.text_button_on_click
          _v64 = _v63.action
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v64.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v64.action_method_name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v64.parameters = []
          for i in range(0, length):
            val7 = google_chat_ros.msg.ActionParameter()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val7.key = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val7.key = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val7.value = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val7.value = str[start:end]
            _v64.parameters.append(val7)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v63.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v63.open_link_url = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v62.image_button_name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v62.image_button_name = str[start:end]
          _v65 = _v62.image_button_on_click
          _v66 = _v65.action
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v66.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v66.action_method_name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v66.parameters = []
          for i in range(0, length):
            val7 = google_chat_ros.msg.ActionParameter()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val7.key = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val7.key = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val7.value = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val7.value = str[start:end]
            _v66.parameters.append(val7)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v65.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v65.open_link_url = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v62.icon = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v62.icon = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v62.original_icon_url = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v62.original_icon_url = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v62.original_icon_filepath = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v62.original_icon_filepath = str[start:end]
          val1.widgets.append(val2)
        self.sections.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.card_actions = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.CardAction()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.action_label = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.action_label = str[start:end]
        _v67 = val1.on_click
        _v68 = _v67.action
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v68.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v68.action_method_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v68.parameters = []
        for i in range(0, length):
          val4 = google_chat_ros.msg.ActionParameter()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val4.key = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val4.key = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val4.value = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val4.value = str[start:end]
          _v68.parameters.append(val4)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v67.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v67.open_link_url = str[start:end]
        self.card_actions.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_d = None
def _get_struct_d():
    global _struct_d
    if _struct_d is None:
        _struct_d = struct.Struct("<d")
    return _struct_d
