# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from google_chat_ros/SendMessageResult.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import google_chat_ros.msg

class SendMessageResult(genpy.Message):
  _md5sum = "2debf2fb1ec68366c318ee077fe23b31"
  _type = "google_chat_ros/SendMessageResult"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# Define the result
google_chat_ros/Message message_result
google_chat_ros/Card[] cards_result
bool done

================================================================================
MSG: google_chat_ros/Message
string name # Resource name in form spaces/*/messages/*
google_chat_ros/User sender # The user who created the message
string create_time # The time at which the message was created in Google Chat server
string text # Plain-text body of the message
string thread_name # The thread the message belongs to
google_chat_ros/Annotation[] annotations # Annotations associated with the plain-text body of the message
string argument_text # Plain-text body of the message with all bot mentions stripped out
google_chat_ros/Attachment[] attachments # User uploaded attachment

================================================================================
MSG: google_chat_ros/User
string name
string display_name
string avatar_url
uint8[] avatar
string email
bool bot
bool human

================================================================================
MSG: google_chat_ros/Annotation
int32 length
int32 start_index
google_chat_ros/User user
## START AnnotationType ##
bool mention
bool slash_command
### END AnnotationType ###
google_chat_ros/SlashCommand command

================================================================================
MSG: google_chat_ros/SlashCommand
google_chat_ros/User user
bool added
bool invoke
string command_name
string command_id
bool triggers_dialog

================================================================================
MSG: google_chat_ros/Attachment
string name
string content_name
string content_type
string thumnail_uri
string download_uri
string localpath
bool drive_file
bool uploaded_content
string attachment_resource_name
string drive_field_id

================================================================================
MSG: google_chat_ros/Card
google_chat_ros/CardHeader header # The header of the card
google_chat_ros/Section[] sections # Sections are separated by a line divider
google_chat_ros/CardAction[] card_actions # The actions of this card
string name # Name of the card

================================================================================
MSG: google_chat_ros/CardHeader
string title
string subtitle
bool image_style_circular # The image's type, makes border
string image_url
string image_filepath # The image in the card header

================================================================================
MSG: google_chat_ros/Section
string header # The header of the section
google_chat_ros/WidgetMarkup[] widgets

================================================================================
MSG: google_chat_ros/WidgetMarkup
google_chat_ros/Button[] buttons
string text_paragraph # Display a text paragraph in this widget
google_chat_ros/Image image # Display an image in this widget
google_chat_ros/KeyValue key_value # Display a key value item in this widget

================================================================================
MSG: google_chat_ros/Button
### FIELD DATA CAN BE ONLY ONE OF THE TEXT BUTTON OR IMAGE BUTTON ###
# A button with text and onclick action
string text_button_name 
google_chat_ros/OnClick text_button_on_click
# An image button with an onclick action
string image_button_name
google_chat_ros/OnClick image_button_on_click
string icon # see https://developers.google.com/chat/api/reference/rest/v1/cards#icon
string original_icon_url # Original icon image's url
string original_icon_filepath # Original icon

================================================================================
MSG: google_chat_ros/OnClick
### FIELD DATA CAN BE ONLY ONE OF THE FOLLOWING ###
google_chat_ros/FormAction action # A form action will be triggered by this onclick if specified
string open_link_url # A link that opens a new window

================================================================================
MSG: google_chat_ros/FormAction
# The form action data associated with an interactive card that was clicked. Only populated for CARD_CLICKED events.
string action_method_name
google_chat_ros/ActionParameter[] parameters

================================================================================
MSG: google_chat_ros/ActionParameter
string key
string value

================================================================================
MSG: google_chat_ros/Image
string image_url
string localpath # If you want to upload new image on google drive, please set this element, not image_uri.
google_chat_ros/OnClick on_click
float64 aspect_ratio # The aspect ratio of this image (width/height). If unset, the server fills it by prefetching the image

================================================================================
MSG: google_chat_ros/KeyValue
string top_label # The text of the top label
string content # The text of the content. Always required
bool content_multiline # If the content should be multiline
string bottom_label # The text of the bottom label
google_chat_ros/OnClick on_click
string icon # see https://developers.google.com/chat/api/reference/rest/v1/cards#icon
string original_icon_url # Original icon image's url
string original_icon_localpath # If you want to upload new image on google drive, please set this element, not original_icon_url.
google_chat_ros/Button button # A button that can be clicked to trigger an action

================================================================================
MSG: google_chat_ros/CardAction
string action_label # The label used to be displayed in the action menu item
google_chat_ros/OnClick on_click
"""
  __slots__ = ['message_result','cards_result','done']
  _slot_types = ['google_chat_ros/Message','google_chat_ros/Card[]','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       message_result,cards_result,done

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SendMessageResult, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.message_result is None:
        self.message_result = google_chat_ros.msg.Message()
      if self.cards_result is None:
        self.cards_result = []
      if self.done is None:
        self.done = False
    else:
      self.message_result = google_chat_ros.msg.Message()
      self.cards_result = []
      self.done = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.message_result.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.message_result.sender.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.message_result.sender.display_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.message_result.sender.avatar_url
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.message_result.sender.avatar
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.message_result.sender.email
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2B().pack(_x.message_result.sender.bot, _x.message_result.sender.human))
      _x = self.message_result.create_time
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.message_result.text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.message_result.thread_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.message_result.annotations)
      buff.write(_struct_I.pack(length))
      for val1 in self.message_result.annotations:
        _x = val1
        buff.write(_get_struct_2i().pack(_x.length, _x.start_index))
        _v1 = val1.user
        _x = _v1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1.display_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1.avatar_url
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1.avatar
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1.email
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1
        buff.write(_get_struct_2B().pack(_x.bot, _x.human))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.mention, _x.slash_command))
        _v2 = val1.command
        _v3 = _v2.user
        _x = _v3.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v3.display_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v3.avatar_url
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v3.avatar
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v3.email
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v3
        buff.write(_get_struct_2B().pack(_x.bot, _x.human))
        _x = _v2
        buff.write(_get_struct_2B().pack(_x.added, _x.invoke))
        _x = _v2.command_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v2.command_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v2.triggers_dialog
        buff.write(_get_struct_B().pack(_x))
      _x = self.message_result.argument_text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.message_result.attachments)
      buff.write(_struct_I.pack(length))
      for val1 in self.message_result.attachments:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.content_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.content_type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.thumnail_uri
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.download_uri
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.localpath
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.drive_file, _x.uploaded_content))
        _x = val1.attachment_resource_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.drive_field_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.cards_result)
      buff.write(_struct_I.pack(length))
      for val1 in self.cards_result:
        _v4 = val1.header
        _x = _v4.title
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v4.subtitle
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v4.image_style_circular
        buff.write(_get_struct_B().pack(_x))
        _x = _v4.image_url
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v4.image_filepath
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.sections)
        buff.write(_struct_I.pack(length))
        for val2 in val1.sections:
          _x = val2.header
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          length = len(val2.widgets)
          buff.write(_struct_I.pack(length))
          for val3 in val2.widgets:
            length = len(val3.buttons)
            buff.write(_struct_I.pack(length))
            for val4 in val3.buttons:
              _x = val4.text_button_name
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _v5 = val4.text_button_on_click
              _v6 = _v5.action
              _x = _v6.action_method_name
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              length = len(_v6.parameters)
              buff.write(_struct_I.pack(length))
              for val7 in _v6.parameters:
                _x = val7.key
                length = len(_x)
                if python3 or type(_x) == unicode:
                  _x = _x.encode('utf-8')
                  length = len(_x)
                buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
                _x = val7.value
                length = len(_x)
                if python3 or type(_x) == unicode:
                  _x = _x.encode('utf-8')
                  length = len(_x)
                buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = _v5.open_link_url
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val4.image_button_name
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _v7 = val4.image_button_on_click
              _v8 = _v7.action
              _x = _v8.action_method_name
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              length = len(_v8.parameters)
              buff.write(_struct_I.pack(length))
              for val7 in _v8.parameters:
                _x = val7.key
                length = len(_x)
                if python3 or type(_x) == unicode:
                  _x = _x.encode('utf-8')
                  length = len(_x)
                buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
                _x = val7.value
                length = len(_x)
                if python3 or type(_x) == unicode:
                  _x = _x.encode('utf-8')
                  length = len(_x)
                buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = _v7.open_link_url
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val4.icon
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val4.original_icon_url
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val4.original_icon_filepath
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val3.text_paragraph
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _v9 = val3.image
            _x = _v9.image_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v9.localpath
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _v10 = _v9.on_click
            _v11 = _v10.action
            _x = _v11.action_method_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            length = len(_v11.parameters)
            buff.write(_struct_I.pack(length))
            for val7 in _v11.parameters:
              _x = val7.key
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val7.value
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v10.open_link_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v9.aspect_ratio
            buff.write(_get_struct_d().pack(_x))
            _v12 = val3.key_value
            _x = _v12.top_label
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v12.content
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v12.content_multiline
            buff.write(_get_struct_B().pack(_x))
            _x = _v12.bottom_label
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _v13 = _v12.on_click
            _v14 = _v13.action
            _x = _v14.action_method_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            length = len(_v14.parameters)
            buff.write(_struct_I.pack(length))
            for val7 in _v14.parameters:
              _x = val7.key
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val7.value
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v13.open_link_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v12.icon
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v12.original_icon_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v12.original_icon_localpath
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _v15 = _v12.button
            _x = _v15.text_button_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _v16 = _v15.text_button_on_click
            _v17 = _v16.action
            _x = _v17.action_method_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            length = len(_v17.parameters)
            buff.write(_struct_I.pack(length))
            for val8 in _v17.parameters:
              _x = val8.key
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val8.value
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v16.open_link_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v15.image_button_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _v18 = _v15.image_button_on_click
            _v19 = _v18.action
            _x = _v19.action_method_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            length = len(_v19.parameters)
            buff.write(_struct_I.pack(length))
            for val8 in _v19.parameters:
              _x = val8.key
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val8.value
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v18.open_link_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v15.icon
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v15.original_icon_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v15.original_icon_filepath
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.card_actions)
        buff.write(_struct_I.pack(length))
        for val2 in val1.card_actions:
          _x = val2.action_label
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _v20 = val2.on_click
          _v21 = _v20.action
          _x = _v21.action_method_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          length = len(_v21.parameters)
          buff.write(_struct_I.pack(length))
          for val5 in _v21.parameters:
            _x = val5.key
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val5.value
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v20.open_link_url
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.done
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.message_result is None:
        self.message_result = google_chat_ros.msg.Message()
      if self.cards_result is None:
        self.cards_result = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message_result.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message_result.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message_result.sender.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message_result.sender.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message_result.sender.display_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message_result.sender.display_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message_result.sender.avatar_url = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message_result.sender.avatar_url = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.message_result.sender.avatar = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message_result.sender.email = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message_result.sender.email = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.message_result.sender.bot, _x.message_result.sender.human,) = _get_struct_2B().unpack(str[start:end])
      self.message_result.sender.bot = bool(self.message_result.sender.bot)
      self.message_result.sender.human = bool(self.message_result.sender.human)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message_result.create_time = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message_result.create_time = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message_result.text = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message_result.text = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message_result.thread_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message_result.thread_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.message_result.annotations = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.Annotation()
        _x = val1
        start = end
        end += 8
        (_x.length, _x.start_index,) = _get_struct_2i().unpack(str[start:end])
        _v22 = val1.user
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v22.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v22.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v22.display_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v22.display_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v22.avatar_url = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v22.avatar_url = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v22.avatar = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v22.email = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v22.email = str[start:end]
        _x = _v22
        start = end
        end += 2
        (_x.bot, _x.human,) = _get_struct_2B().unpack(str[start:end])
        _v22.bot = bool(_v22.bot)
        _v22.human = bool(_v22.human)
        _x = val1
        start = end
        end += 2
        (_x.mention, _x.slash_command,) = _get_struct_2B().unpack(str[start:end])
        val1.mention = bool(val1.mention)
        val1.slash_command = bool(val1.slash_command)
        _v23 = val1.command
        _v24 = _v23.user
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v24.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v24.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v24.display_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v24.display_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v24.avatar_url = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v24.avatar_url = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v24.avatar = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v24.email = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v24.email = str[start:end]
        _x = _v24
        start = end
        end += 2
        (_x.bot, _x.human,) = _get_struct_2B().unpack(str[start:end])
        _v24.bot = bool(_v24.bot)
        _v24.human = bool(_v24.human)
        _x = _v23
        start = end
        end += 2
        (_x.added, _x.invoke,) = _get_struct_2B().unpack(str[start:end])
        _v23.added = bool(_v23.added)
        _v23.invoke = bool(_v23.invoke)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v23.command_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v23.command_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v23.command_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v23.command_id = str[start:end]
        start = end
        end += 1
        (_v23.triggers_dialog,) = _get_struct_B().unpack(str[start:end])
        _v23.triggers_dialog = bool(_v23.triggers_dialog)
        self.message_result.annotations.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message_result.argument_text = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message_result.argument_text = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.message_result.attachments = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.Attachment()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.content_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.content_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.content_type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.content_type = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.thumnail_uri = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.thumnail_uri = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.download_uri = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.download_uri = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.localpath = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.localpath = str[start:end]
        _x = val1
        start = end
        end += 2
        (_x.drive_file, _x.uploaded_content,) = _get_struct_2B().unpack(str[start:end])
        val1.drive_file = bool(val1.drive_file)
        val1.uploaded_content = bool(val1.uploaded_content)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.attachment_resource_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.attachment_resource_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.drive_field_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.drive_field_id = str[start:end]
        self.message_result.attachments.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cards_result = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.Card()
        _v25 = val1.header
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v25.title = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v25.title = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v25.subtitle = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v25.subtitle = str[start:end]
        start = end
        end += 1
        (_v25.image_style_circular,) = _get_struct_B().unpack(str[start:end])
        _v25.image_style_circular = bool(_v25.image_style_circular)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v25.image_url = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v25.image_url = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v25.image_filepath = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v25.image_filepath = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.sections = []
        for i in range(0, length):
          val2 = google_chat_ros.msg.Section()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.header = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.header = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.widgets = []
          for i in range(0, length):
            val3 = google_chat_ros.msg.WidgetMarkup()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            val3.buttons = []
            for i in range(0, length):
              val4 = google_chat_ros.msg.Button()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val4.text_button_name = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val4.text_button_name = str[start:end]
              _v26 = val4.text_button_on_click
              _v27 = _v26.action
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                _v27.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
              else:
                _v27.action_method_name = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              _v27.parameters = []
              for i in range(0, length):
                val7 = google_chat_ros.msg.ActionParameter()
                start = end
                end += 4
                (length,) = _struct_I.unpack(str[start:end])
                start = end
                end += length
                if python3:
                  val7.key = str[start:end].decode('utf-8', 'rosmsg')
                else:
                  val7.key = str[start:end]
                start = end
                end += 4
                (length,) = _struct_I.unpack(str[start:end])
                start = end
                end += length
                if python3:
                  val7.value = str[start:end].decode('utf-8', 'rosmsg')
                else:
                  val7.value = str[start:end]
                _v27.parameters.append(val7)
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                _v26.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
              else:
                _v26.open_link_url = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val4.image_button_name = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val4.image_button_name = str[start:end]
              _v28 = val4.image_button_on_click
              _v29 = _v28.action
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                _v29.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
              else:
                _v29.action_method_name = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              _v29.parameters = []
              for i in range(0, length):
                val7 = google_chat_ros.msg.ActionParameter()
                start = end
                end += 4
                (length,) = _struct_I.unpack(str[start:end])
                start = end
                end += length
                if python3:
                  val7.key = str[start:end].decode('utf-8', 'rosmsg')
                else:
                  val7.key = str[start:end]
                start = end
                end += 4
                (length,) = _struct_I.unpack(str[start:end])
                start = end
                end += length
                if python3:
                  val7.value = str[start:end].decode('utf-8', 'rosmsg')
                else:
                  val7.value = str[start:end]
                _v29.parameters.append(val7)
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                _v28.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
              else:
                _v28.open_link_url = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val4.icon = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val4.icon = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val4.original_icon_url = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val4.original_icon_url = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val4.original_icon_filepath = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val4.original_icon_filepath = str[start:end]
              val3.buttons.append(val4)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.text_paragraph = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val3.text_paragraph = str[start:end]
            _v30 = val3.image
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v30.image_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v30.image_url = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v30.localpath = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v30.localpath = str[start:end]
            _v31 = _v30.on_click
            _v32 = _v31.action
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v32.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v32.action_method_name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v32.parameters = []
            for i in range(0, length):
              val7 = google_chat_ros.msg.ActionParameter()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val7.key = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val7.key = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val7.value = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val7.value = str[start:end]
              _v32.parameters.append(val7)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v31.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v31.open_link_url = str[start:end]
            start = end
            end += 8
            (_v30.aspect_ratio,) = _get_struct_d().unpack(str[start:end])
            _v33 = val3.key_value
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v33.top_label = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v33.top_label = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v33.content = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v33.content = str[start:end]
            start = end
            end += 1
            (_v33.content_multiline,) = _get_struct_B().unpack(str[start:end])
            _v33.content_multiline = bool(_v33.content_multiline)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v33.bottom_label = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v33.bottom_label = str[start:end]
            _v34 = _v33.on_click
            _v35 = _v34.action
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v35.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v35.action_method_name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v35.parameters = []
            for i in range(0, length):
              val7 = google_chat_ros.msg.ActionParameter()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val7.key = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val7.key = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val7.value = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val7.value = str[start:end]
              _v35.parameters.append(val7)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v34.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v34.open_link_url = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v33.icon = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v33.icon = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v33.original_icon_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v33.original_icon_url = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v33.original_icon_localpath = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v33.original_icon_localpath = str[start:end]
            _v36 = _v33.button
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v36.text_button_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v36.text_button_name = str[start:end]
            _v37 = _v36.text_button_on_click
            _v38 = _v37.action
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v38.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v38.action_method_name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v38.parameters = []
            for i in range(0, length):
              val8 = google_chat_ros.msg.ActionParameter()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val8.key = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val8.key = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val8.value = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val8.value = str[start:end]
              _v38.parameters.append(val8)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v37.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v37.open_link_url = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v36.image_button_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v36.image_button_name = str[start:end]
            _v39 = _v36.image_button_on_click
            _v40 = _v39.action
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v40.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v40.action_method_name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v40.parameters = []
            for i in range(0, length):
              val8 = google_chat_ros.msg.ActionParameter()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val8.key = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val8.key = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val8.value = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val8.value = str[start:end]
              _v40.parameters.append(val8)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v39.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v39.open_link_url = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v36.icon = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v36.icon = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v36.original_icon_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v36.original_icon_url = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v36.original_icon_filepath = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v36.original_icon_filepath = str[start:end]
            val2.widgets.append(val3)
          val1.sections.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.card_actions = []
        for i in range(0, length):
          val2 = google_chat_ros.msg.CardAction()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.action_label = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.action_label = str[start:end]
          _v41 = val2.on_click
          _v42 = _v41.action
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v42.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v42.action_method_name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v42.parameters = []
          for i in range(0, length):
            val5 = google_chat_ros.msg.ActionParameter()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val5.key = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val5.key = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val5.value = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val5.value = str[start:end]
            _v42.parameters.append(val5)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v41.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v41.open_link_url = str[start:end]
          val1.card_actions.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        self.cards_result.append(val1)
      start = end
      end += 1
      (self.done,) = _get_struct_B().unpack(str[start:end])
      self.done = bool(self.done)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.message_result.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.message_result.sender.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.message_result.sender.display_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.message_result.sender.avatar_url
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.message_result.sender.avatar
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.message_result.sender.email
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2B().pack(_x.message_result.sender.bot, _x.message_result.sender.human))
      _x = self.message_result.create_time
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.message_result.text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.message_result.thread_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.message_result.annotations)
      buff.write(_struct_I.pack(length))
      for val1 in self.message_result.annotations:
        _x = val1
        buff.write(_get_struct_2i().pack(_x.length, _x.start_index))
        _v43 = val1.user
        _x = _v43.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v43.display_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v43.avatar_url
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v43.avatar
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v43.email
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v43
        buff.write(_get_struct_2B().pack(_x.bot, _x.human))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.mention, _x.slash_command))
        _v44 = val1.command
        _v45 = _v44.user
        _x = _v45.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v45.display_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v45.avatar_url
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v45.avatar
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v45.email
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v45
        buff.write(_get_struct_2B().pack(_x.bot, _x.human))
        _x = _v44
        buff.write(_get_struct_2B().pack(_x.added, _x.invoke))
        _x = _v44.command_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v44.command_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v44.triggers_dialog
        buff.write(_get_struct_B().pack(_x))
      _x = self.message_result.argument_text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.message_result.attachments)
      buff.write(_struct_I.pack(length))
      for val1 in self.message_result.attachments:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.content_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.content_type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.thumnail_uri
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.download_uri
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.localpath
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.drive_file, _x.uploaded_content))
        _x = val1.attachment_resource_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.drive_field_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.cards_result)
      buff.write(_struct_I.pack(length))
      for val1 in self.cards_result:
        _v46 = val1.header
        _x = _v46.title
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v46.subtitle
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v46.image_style_circular
        buff.write(_get_struct_B().pack(_x))
        _x = _v46.image_url
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v46.image_filepath
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.sections)
        buff.write(_struct_I.pack(length))
        for val2 in val1.sections:
          _x = val2.header
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          length = len(val2.widgets)
          buff.write(_struct_I.pack(length))
          for val3 in val2.widgets:
            length = len(val3.buttons)
            buff.write(_struct_I.pack(length))
            for val4 in val3.buttons:
              _x = val4.text_button_name
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _v47 = val4.text_button_on_click
              _v48 = _v47.action
              _x = _v48.action_method_name
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              length = len(_v48.parameters)
              buff.write(_struct_I.pack(length))
              for val7 in _v48.parameters:
                _x = val7.key
                length = len(_x)
                if python3 or type(_x) == unicode:
                  _x = _x.encode('utf-8')
                  length = len(_x)
                buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
                _x = val7.value
                length = len(_x)
                if python3 or type(_x) == unicode:
                  _x = _x.encode('utf-8')
                  length = len(_x)
                buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = _v47.open_link_url
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val4.image_button_name
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _v49 = val4.image_button_on_click
              _v50 = _v49.action
              _x = _v50.action_method_name
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              length = len(_v50.parameters)
              buff.write(_struct_I.pack(length))
              for val7 in _v50.parameters:
                _x = val7.key
                length = len(_x)
                if python3 or type(_x) == unicode:
                  _x = _x.encode('utf-8')
                  length = len(_x)
                buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
                _x = val7.value
                length = len(_x)
                if python3 or type(_x) == unicode:
                  _x = _x.encode('utf-8')
                  length = len(_x)
                buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = _v49.open_link_url
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val4.icon
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val4.original_icon_url
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val4.original_icon_filepath
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val3.text_paragraph
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _v51 = val3.image
            _x = _v51.image_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v51.localpath
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _v52 = _v51.on_click
            _v53 = _v52.action
            _x = _v53.action_method_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            length = len(_v53.parameters)
            buff.write(_struct_I.pack(length))
            for val7 in _v53.parameters:
              _x = val7.key
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val7.value
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v52.open_link_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v51.aspect_ratio
            buff.write(_get_struct_d().pack(_x))
            _v54 = val3.key_value
            _x = _v54.top_label
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v54.content
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v54.content_multiline
            buff.write(_get_struct_B().pack(_x))
            _x = _v54.bottom_label
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _v55 = _v54.on_click
            _v56 = _v55.action
            _x = _v56.action_method_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            length = len(_v56.parameters)
            buff.write(_struct_I.pack(length))
            for val7 in _v56.parameters:
              _x = val7.key
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val7.value
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v55.open_link_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v54.icon
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v54.original_icon_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v54.original_icon_localpath
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _v57 = _v54.button
            _x = _v57.text_button_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _v58 = _v57.text_button_on_click
            _v59 = _v58.action
            _x = _v59.action_method_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            length = len(_v59.parameters)
            buff.write(_struct_I.pack(length))
            for val8 in _v59.parameters:
              _x = val8.key
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val8.value
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v58.open_link_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v57.image_button_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _v60 = _v57.image_button_on_click
            _v61 = _v60.action
            _x = _v61.action_method_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            length = len(_v61.parameters)
            buff.write(_struct_I.pack(length))
            for val8 in _v61.parameters:
              _x = val8.key
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
              _x = val8.value
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v60.open_link_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v57.icon
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v57.original_icon_url
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v57.original_icon_filepath
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.card_actions)
        buff.write(_struct_I.pack(length))
        for val2 in val1.card_actions:
          _x = val2.action_label
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _v62 = val2.on_click
          _v63 = _v62.action
          _x = _v63.action_method_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          length = len(_v63.parameters)
          buff.write(_struct_I.pack(length))
          for val5 in _v63.parameters:
            _x = val5.key
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = val5.value
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v62.open_link_url
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.done
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.message_result is None:
        self.message_result = google_chat_ros.msg.Message()
      if self.cards_result is None:
        self.cards_result = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message_result.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message_result.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message_result.sender.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message_result.sender.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message_result.sender.display_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message_result.sender.display_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message_result.sender.avatar_url = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message_result.sender.avatar_url = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.message_result.sender.avatar = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message_result.sender.email = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message_result.sender.email = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.message_result.sender.bot, _x.message_result.sender.human,) = _get_struct_2B().unpack(str[start:end])
      self.message_result.sender.bot = bool(self.message_result.sender.bot)
      self.message_result.sender.human = bool(self.message_result.sender.human)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message_result.create_time = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message_result.create_time = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message_result.text = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message_result.text = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message_result.thread_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message_result.thread_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.message_result.annotations = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.Annotation()
        _x = val1
        start = end
        end += 8
        (_x.length, _x.start_index,) = _get_struct_2i().unpack(str[start:end])
        _v64 = val1.user
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v64.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v64.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v64.display_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v64.display_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v64.avatar_url = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v64.avatar_url = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v64.avatar = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v64.email = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v64.email = str[start:end]
        _x = _v64
        start = end
        end += 2
        (_x.bot, _x.human,) = _get_struct_2B().unpack(str[start:end])
        _v64.bot = bool(_v64.bot)
        _v64.human = bool(_v64.human)
        _x = val1
        start = end
        end += 2
        (_x.mention, _x.slash_command,) = _get_struct_2B().unpack(str[start:end])
        val1.mention = bool(val1.mention)
        val1.slash_command = bool(val1.slash_command)
        _v65 = val1.command
        _v66 = _v65.user
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v66.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v66.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v66.display_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v66.display_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v66.avatar_url = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v66.avatar_url = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v66.avatar = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v66.email = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v66.email = str[start:end]
        _x = _v66
        start = end
        end += 2
        (_x.bot, _x.human,) = _get_struct_2B().unpack(str[start:end])
        _v66.bot = bool(_v66.bot)
        _v66.human = bool(_v66.human)
        _x = _v65
        start = end
        end += 2
        (_x.added, _x.invoke,) = _get_struct_2B().unpack(str[start:end])
        _v65.added = bool(_v65.added)
        _v65.invoke = bool(_v65.invoke)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v65.command_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v65.command_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v65.command_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v65.command_id = str[start:end]
        start = end
        end += 1
        (_v65.triggers_dialog,) = _get_struct_B().unpack(str[start:end])
        _v65.triggers_dialog = bool(_v65.triggers_dialog)
        self.message_result.annotations.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message_result.argument_text = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message_result.argument_text = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.message_result.attachments = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.Attachment()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.content_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.content_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.content_type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.content_type = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.thumnail_uri = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.thumnail_uri = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.download_uri = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.download_uri = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.localpath = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.localpath = str[start:end]
        _x = val1
        start = end
        end += 2
        (_x.drive_file, _x.uploaded_content,) = _get_struct_2B().unpack(str[start:end])
        val1.drive_file = bool(val1.drive_file)
        val1.uploaded_content = bool(val1.uploaded_content)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.attachment_resource_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.attachment_resource_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.drive_field_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.drive_field_id = str[start:end]
        self.message_result.attachments.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cards_result = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.Card()
        _v67 = val1.header
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v67.title = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v67.title = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v67.subtitle = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v67.subtitle = str[start:end]
        start = end
        end += 1
        (_v67.image_style_circular,) = _get_struct_B().unpack(str[start:end])
        _v67.image_style_circular = bool(_v67.image_style_circular)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v67.image_url = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v67.image_url = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v67.image_filepath = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v67.image_filepath = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.sections = []
        for i in range(0, length):
          val2 = google_chat_ros.msg.Section()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.header = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.header = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.widgets = []
          for i in range(0, length):
            val3 = google_chat_ros.msg.WidgetMarkup()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            val3.buttons = []
            for i in range(0, length):
              val4 = google_chat_ros.msg.Button()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val4.text_button_name = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val4.text_button_name = str[start:end]
              _v68 = val4.text_button_on_click
              _v69 = _v68.action
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                _v69.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
              else:
                _v69.action_method_name = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              _v69.parameters = []
              for i in range(0, length):
                val7 = google_chat_ros.msg.ActionParameter()
                start = end
                end += 4
                (length,) = _struct_I.unpack(str[start:end])
                start = end
                end += length
                if python3:
                  val7.key = str[start:end].decode('utf-8', 'rosmsg')
                else:
                  val7.key = str[start:end]
                start = end
                end += 4
                (length,) = _struct_I.unpack(str[start:end])
                start = end
                end += length
                if python3:
                  val7.value = str[start:end].decode('utf-8', 'rosmsg')
                else:
                  val7.value = str[start:end]
                _v69.parameters.append(val7)
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                _v68.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
              else:
                _v68.open_link_url = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val4.image_button_name = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val4.image_button_name = str[start:end]
              _v70 = val4.image_button_on_click
              _v71 = _v70.action
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                _v71.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
              else:
                _v71.action_method_name = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              _v71.parameters = []
              for i in range(0, length):
                val7 = google_chat_ros.msg.ActionParameter()
                start = end
                end += 4
                (length,) = _struct_I.unpack(str[start:end])
                start = end
                end += length
                if python3:
                  val7.key = str[start:end].decode('utf-8', 'rosmsg')
                else:
                  val7.key = str[start:end]
                start = end
                end += 4
                (length,) = _struct_I.unpack(str[start:end])
                start = end
                end += length
                if python3:
                  val7.value = str[start:end].decode('utf-8', 'rosmsg')
                else:
                  val7.value = str[start:end]
                _v71.parameters.append(val7)
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                _v70.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
              else:
                _v70.open_link_url = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val4.icon = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val4.icon = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val4.original_icon_url = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val4.original_icon_url = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val4.original_icon_filepath = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val4.original_icon_filepath = str[start:end]
              val3.buttons.append(val4)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.text_paragraph = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val3.text_paragraph = str[start:end]
            _v72 = val3.image
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v72.image_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v72.image_url = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v72.localpath = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v72.localpath = str[start:end]
            _v73 = _v72.on_click
            _v74 = _v73.action
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v74.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v74.action_method_name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v74.parameters = []
            for i in range(0, length):
              val7 = google_chat_ros.msg.ActionParameter()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val7.key = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val7.key = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val7.value = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val7.value = str[start:end]
              _v74.parameters.append(val7)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v73.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v73.open_link_url = str[start:end]
            start = end
            end += 8
            (_v72.aspect_ratio,) = _get_struct_d().unpack(str[start:end])
            _v75 = val3.key_value
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v75.top_label = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v75.top_label = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v75.content = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v75.content = str[start:end]
            start = end
            end += 1
            (_v75.content_multiline,) = _get_struct_B().unpack(str[start:end])
            _v75.content_multiline = bool(_v75.content_multiline)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v75.bottom_label = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v75.bottom_label = str[start:end]
            _v76 = _v75.on_click
            _v77 = _v76.action
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v77.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v77.action_method_name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v77.parameters = []
            for i in range(0, length):
              val7 = google_chat_ros.msg.ActionParameter()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val7.key = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val7.key = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val7.value = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val7.value = str[start:end]
              _v77.parameters.append(val7)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v76.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v76.open_link_url = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v75.icon = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v75.icon = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v75.original_icon_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v75.original_icon_url = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v75.original_icon_localpath = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v75.original_icon_localpath = str[start:end]
            _v78 = _v75.button
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v78.text_button_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v78.text_button_name = str[start:end]
            _v79 = _v78.text_button_on_click
            _v80 = _v79.action
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v80.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v80.action_method_name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v80.parameters = []
            for i in range(0, length):
              val8 = google_chat_ros.msg.ActionParameter()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val8.key = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val8.key = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val8.value = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val8.value = str[start:end]
              _v80.parameters.append(val8)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v79.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v79.open_link_url = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v78.image_button_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v78.image_button_name = str[start:end]
            _v81 = _v78.image_button_on_click
            _v82 = _v81.action
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v82.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v82.action_method_name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v82.parameters = []
            for i in range(0, length):
              val8 = google_chat_ros.msg.ActionParameter()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val8.key = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val8.key = str[start:end]
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val8.value = str[start:end].decode('utf-8', 'rosmsg')
              else:
                val8.value = str[start:end]
              _v82.parameters.append(val8)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v81.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v81.open_link_url = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v78.icon = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v78.icon = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v78.original_icon_url = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v78.original_icon_url = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v78.original_icon_filepath = str[start:end].decode('utf-8', 'rosmsg')
            else:
              _v78.original_icon_filepath = str[start:end]
            val2.widgets.append(val3)
          val1.sections.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.card_actions = []
        for i in range(0, length):
          val2 = google_chat_ros.msg.CardAction()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.action_label = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.action_label = str[start:end]
          _v83 = val2.on_click
          _v84 = _v83.action
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v84.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v84.action_method_name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v84.parameters = []
          for i in range(0, length):
            val5 = google_chat_ros.msg.ActionParameter()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val5.key = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val5.key = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val5.value = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val5.value = str[start:end]
            _v84.parameters.append(val5)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v83.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
          else:
            _v83.open_link_url = str[start:end]
          val1.card_actions.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        self.cards_result.append(val1)
      start = end
      end += 1
      (self.done,) = _get_struct_B().unpack(str[start:end])
      self.done = bool(self.done)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_2i = None
def _get_struct_2i():
    global _struct_2i
    if _struct_2i is None:
        _struct_2i = struct.Struct("<2i")
    return _struct_2i
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_d = None
def _get_struct_d():
    global _struct_d
    if _struct_d is None:
        _struct_d = struct.Struct("<d")
    return _struct_d
