// Auto-generated. Do not edit!

// (in-package google_chat_ros.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Space = require('./Space.js');
let Message = require('./Message.js');
let User = require('./User.js');
let FormAction = require('./FormAction.js');

//-----------------------------------------------------------

class CardEvent {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.event_time = null;
      this.space = null;
      this.message = null;
      this.user = null;
      this.action = null;
    }
    else {
      if (initObj.hasOwnProperty('event_time')) {
        this.event_time = initObj.event_time
      }
      else {
        this.event_time = '';
      }
      if (initObj.hasOwnProperty('space')) {
        this.space = initObj.space
      }
      else {
        this.space = new Space();
      }
      if (initObj.hasOwnProperty('message')) {
        this.message = initObj.message
      }
      else {
        this.message = new Message();
      }
      if (initObj.hasOwnProperty('user')) {
        this.user = initObj.user
      }
      else {
        this.user = new User();
      }
      if (initObj.hasOwnProperty('action')) {
        this.action = initObj.action
      }
      else {
        this.action = new FormAction();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type CardEvent
    // Serialize message field [event_time]
    bufferOffset = _serializer.string(obj.event_time, buffer, bufferOffset);
    // Serialize message field [space]
    bufferOffset = Space.serialize(obj.space, buffer, bufferOffset);
    // Serialize message field [message]
    bufferOffset = Message.serialize(obj.message, buffer, bufferOffset);
    // Serialize message field [user]
    bufferOffset = User.serialize(obj.user, buffer, bufferOffset);
    // Serialize message field [action]
    bufferOffset = FormAction.serialize(obj.action, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type CardEvent
    let len;
    let data = new CardEvent(null);
    // Deserialize message field [event_time]
    data.event_time = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [space]
    data.space = Space.deserialize(buffer, bufferOffset);
    // Deserialize message field [message]
    data.message = Message.deserialize(buffer, bufferOffset);
    // Deserialize message field [user]
    data.user = User.deserialize(buffer, bufferOffset);
    // Deserialize message field [action]
    data.action = FormAction.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.event_time);
    length += Space.getMessageSize(object.space);
    length += Message.getMessageSize(object.message);
    length += User.getMessageSize(object.user);
    length += FormAction.getMessageSize(object.action);
    return length + 4;
  }

  static datatype() {
    // Returns string type for a message object
    return 'google_chat_ros/CardEvent';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'cf8d6a04ed99a4664e48a179c2768325';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    string event_time
    google_chat_ros/Space space
    google_chat_ros/Message message # TODO:check is it required
    google_chat_ros/User user
    google_chat_ros/FormAction action
    
    ================================================================================
    MSG: google_chat_ros/Space
    string name
    string display_name
    bool room # is chat room
    bool dm # is direct message
    
    ================================================================================
    MSG: google_chat_ros/Message
    string name # Resource name in form spaces/*/messages/*
    google_chat_ros/User sender # The user who created the message
    string create_time # The time at which the message was created in Google Chat server
    string text # Plain-text body of the message
    string thread_name # The thread the message belongs to
    google_chat_ros/Annotation[] annotations # Annotations associated with the plain-text body of the message
    string argument_text # Plain-text body of the message with all bot mentions stripped out
    google_chat_ros/Attachment[] attachments # User uploaded attachment
    
    ================================================================================
    MSG: google_chat_ros/User
    string name
    string display_name
    string avatar_url
    uint8[] avatar
    string email
    bool bot
    bool human
    
    ================================================================================
    MSG: google_chat_ros/Annotation
    int32 length
    int32 start_index
    google_chat_ros/User user
    ## START AnnotationType ##
    bool mention
    bool slash_command
    ### END AnnotationType ###
    google_chat_ros/SlashCommand command
    
    ================================================================================
    MSG: google_chat_ros/SlashCommand
    google_chat_ros/User user
    bool added
    bool invoke
    string command_name
    string command_id
    bool triggers_dialog
    
    ================================================================================
    MSG: google_chat_ros/Attachment
    string name
    string content_name
    string content_type
    string thumnail_uri
    string download_uri
    string localpath
    bool drive_file
    bool uploaded_content
    string attachment_resource_name
    string drive_field_id
    
    ================================================================================
    MSG: google_chat_ros/FormAction
    # The form action data associated with an interactive card that was clicked. Only populated for CARD_CLICKED events.
    string action_method_name
    google_chat_ros/ActionParameter[] parameters
    
    ================================================================================
    MSG: google_chat_ros/ActionParameter
    string key
    string value
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new CardEvent(null);
    if (msg.event_time !== undefined) {
      resolved.event_time = msg.event_time;
    }
    else {
      resolved.event_time = ''
    }

    if (msg.space !== undefined) {
      resolved.space = Space.Resolve(msg.space)
    }
    else {
      resolved.space = new Space()
    }

    if (msg.message !== undefined) {
      resolved.message = Message.Resolve(msg.message)
    }
    else {
      resolved.message = new Message()
    }

    if (msg.user !== undefined) {
      resolved.user = User.Resolve(msg.user)
    }
    else {
      resolved.user = new User()
    }

    if (msg.action !== undefined) {
      resolved.action = FormAction.Resolve(msg.action)
    }
    else {
      resolved.action = new FormAction()
    }

    return resolved;
    }
};

module.exports = CardEvent;
