// Auto-generated. Do not edit!

// (in-package google_chat_ros.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let WidgetMarkup = require('./WidgetMarkup.js');

//-----------------------------------------------------------

class Section {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.widgets = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = '';
      }
      if (initObj.hasOwnProperty('widgets')) {
        this.widgets = initObj.widgets
      }
      else {
        this.widgets = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Section
    // Serialize message field [header]
    bufferOffset = _serializer.string(obj.header, buffer, bufferOffset);
    // Serialize message field [widgets]
    // Serialize the length for message field [widgets]
    bufferOffset = _serializer.uint32(obj.widgets.length, buffer, bufferOffset);
    obj.widgets.forEach((val) => {
      bufferOffset = WidgetMarkup.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Section
    let len;
    let data = new Section(null);
    // Deserialize message field [header]
    data.header = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [widgets]
    // Deserialize array length for message field [widgets]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.widgets = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.widgets[i] = WidgetMarkup.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.header);
    object.widgets.forEach((val) => {
      length += WidgetMarkup.getMessageSize(val);
    });
    return length + 8;
  }

  static datatype() {
    // Returns string type for a message object
    return 'google_chat_ros/Section';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '90eb3f68d10d183e560f956adae61989';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    string header # The header of the section
    google_chat_ros/WidgetMarkup[] widgets
    
    ================================================================================
    MSG: google_chat_ros/WidgetMarkup
    google_chat_ros/Button[] buttons
    string text_paragraph # Display a text paragraph in this widget
    google_chat_ros/Image image # Display an image in this widget
    google_chat_ros/KeyValue key_value # Display a key value item in this widget
    
    ================================================================================
    MSG: google_chat_ros/Button
    ### FIELD DATA CAN BE ONLY ONE OF THE TEXT BUTTON OR IMAGE BUTTON ###
    # A button with text and onclick action
    string text_button_name 
    google_chat_ros/OnClick text_button_on_click
    # An image button with an onclick action
    string image_button_name
    google_chat_ros/OnClick image_button_on_click
    string icon # see https://developers.google.com/chat/api/reference/rest/v1/cards#icon
    string original_icon_url # Original icon image's url
    string original_icon_filepath # Original icon
    
    ================================================================================
    MSG: google_chat_ros/OnClick
    ### FIELD DATA CAN BE ONLY ONE OF THE FOLLOWING ###
    google_chat_ros/FormAction action # A form action will be triggered by this onclick if specified
    string open_link_url # A link that opens a new window
    
    ================================================================================
    MSG: google_chat_ros/FormAction
    # The form action data associated with an interactive card that was clicked. Only populated for CARD_CLICKED events.
    string action_method_name
    google_chat_ros/ActionParameter[] parameters
    
    ================================================================================
    MSG: google_chat_ros/ActionParameter
    string key
    string value
    
    ================================================================================
    MSG: google_chat_ros/Image
    string image_url
    string localpath # If you want to upload new image on google drive, please set this element, not image_uri.
    google_chat_ros/OnClick on_click
    float64 aspect_ratio # The aspect ratio of this image (width/height). If unset, the server fills it by prefetching the image
    
    ================================================================================
    MSG: google_chat_ros/KeyValue
    string top_label # The text of the top label
    string content # The text of the content. Always required
    bool content_multiline # If the content should be multiline
    string bottom_label # The text of the bottom label
    google_chat_ros/OnClick on_click
    string icon # see https://developers.google.com/chat/api/reference/rest/v1/cards#icon
    string original_icon_url # Original icon image's url
    string original_icon_localpath # If you want to upload new image on google drive, please set this element, not original_icon_url.
    google_chat_ros/Button button # A button that can be clicked to trigger an action
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Section(null);
    if (msg.header !== undefined) {
      resolved.header = msg.header;
    }
    else {
      resolved.header = ''
    }

    if (msg.widgets !== undefined) {
      resolved.widgets = new Array(msg.widgets.length);
      for (let i = 0; i < resolved.widgets.length; ++i) {
        resolved.widgets[i] = WidgetMarkup.Resolve(msg.widgets[i]);
      }
    }
    else {
      resolved.widgets = []
    }

    return resolved;
    }
};

module.exports = Section;
