// Auto-generated. Do not edit!

// (in-package google_chat_ros.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Card = require('./Card.js');

//-----------------------------------------------------------

class SendMessageGoal {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.text = null;
      this.cards = null;
      this.update_message = null;
      this.thread_name = null;
      this.space = null;
    }
    else {
      if (initObj.hasOwnProperty('text')) {
        this.text = initObj.text
      }
      else {
        this.text = '';
      }
      if (initObj.hasOwnProperty('cards')) {
        this.cards = initObj.cards
      }
      else {
        this.cards = [];
      }
      if (initObj.hasOwnProperty('update_message')) {
        this.update_message = initObj.update_message
      }
      else {
        this.update_message = false;
      }
      if (initObj.hasOwnProperty('thread_name')) {
        this.thread_name = initObj.thread_name
      }
      else {
        this.thread_name = '';
      }
      if (initObj.hasOwnProperty('space')) {
        this.space = initObj.space
      }
      else {
        this.space = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SendMessageGoal
    // Serialize message field [text]
    bufferOffset = _serializer.string(obj.text, buffer, bufferOffset);
    // Serialize message field [cards]
    // Serialize the length for message field [cards]
    bufferOffset = _serializer.uint32(obj.cards.length, buffer, bufferOffset);
    obj.cards.forEach((val) => {
      bufferOffset = Card.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [update_message]
    bufferOffset = _serializer.bool(obj.update_message, buffer, bufferOffset);
    // Serialize message field [thread_name]
    bufferOffset = _serializer.string(obj.thread_name, buffer, bufferOffset);
    // Serialize message field [space]
    bufferOffset = _serializer.string(obj.space, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SendMessageGoal
    let len;
    let data = new SendMessageGoal(null);
    // Deserialize message field [text]
    data.text = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [cards]
    // Deserialize array length for message field [cards]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.cards = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.cards[i] = Card.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [update_message]
    data.update_message = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [thread_name]
    data.thread_name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [space]
    data.space = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.text);
    object.cards.forEach((val) => {
      length += Card.getMessageSize(val);
    });
    length += _getByteLength(object.thread_name);
    length += _getByteLength(object.space);
    return length + 17;
  }

  static datatype() {
    // Returns string type for a message object
    return 'google_chat_ros/SendMessageGoal';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '228383d98cf45717fe53712a5be9ee06';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    # Define the goal
    string text
    google_chat_ros/Card[] cards
    bool update_message # Not creating new message, but rewrite existing message
    string thread_name
    string space
    
    ================================================================================
    MSG: google_chat_ros/Card
    google_chat_ros/CardHeader header # The header of the card
    google_chat_ros/Section[] sections # Sections are separated by a line divider
    google_chat_ros/CardAction[] card_actions # The actions of this card
    string name # Name of the card
    
    ================================================================================
    MSG: google_chat_ros/CardHeader
    string title
    string subtitle
    bool image_style_circular # The image's type, makes border
    string image_url
    string image_filepath # The image in the card header
    
    ================================================================================
    MSG: google_chat_ros/Section
    string header # The header of the section
    google_chat_ros/WidgetMarkup[] widgets
    
    ================================================================================
    MSG: google_chat_ros/WidgetMarkup
    google_chat_ros/Button[] buttons
    string text_paragraph # Display a text paragraph in this widget
    google_chat_ros/Image image # Display an image in this widget
    google_chat_ros/KeyValue key_value # Display a key value item in this widget
    
    ================================================================================
    MSG: google_chat_ros/Button
    ### FIELD DATA CAN BE ONLY ONE OF THE TEXT BUTTON OR IMAGE BUTTON ###
    # A button with text and onclick action
    string text_button_name 
    google_chat_ros/OnClick text_button_on_click
    # An image button with an onclick action
    string image_button_name
    google_chat_ros/OnClick image_button_on_click
    string icon # see https://developers.google.com/chat/api/reference/rest/v1/cards#icon
    string original_icon_url # Original icon image's url
    string original_icon_filepath # Original icon
    
    ================================================================================
    MSG: google_chat_ros/OnClick
    ### FIELD DATA CAN BE ONLY ONE OF THE FOLLOWING ###
    google_chat_ros/FormAction action # A form action will be triggered by this onclick if specified
    string open_link_url # A link that opens a new window
    
    ================================================================================
    MSG: google_chat_ros/FormAction
    # The form action data associated with an interactive card that was clicked. Only populated for CARD_CLICKED events.
    string action_method_name
    google_chat_ros/ActionParameter[] parameters
    
    ================================================================================
    MSG: google_chat_ros/ActionParameter
    string key
    string value
    
    ================================================================================
    MSG: google_chat_ros/Image
    string image_url
    string localpath # If you want to upload new image on google drive, please set this element, not image_uri.
    google_chat_ros/OnClick on_click
    float64 aspect_ratio # The aspect ratio of this image (width/height). If unset, the server fills it by prefetching the image
    
    ================================================================================
    MSG: google_chat_ros/KeyValue
    string top_label # The text of the top label
    string content # The text of the content. Always required
    bool content_multiline # If the content should be multiline
    string bottom_label # The text of the bottom label
    google_chat_ros/OnClick on_click
    string icon # see https://developers.google.com/chat/api/reference/rest/v1/cards#icon
    string original_icon_url # Original icon image's url
    string original_icon_localpath # If you want to upload new image on google drive, please set this element, not original_icon_url.
    google_chat_ros/Button button # A button that can be clicked to trigger an action
    
    ================================================================================
    MSG: google_chat_ros/CardAction
    string action_label # The label used to be displayed in the action menu item
    google_chat_ros/OnClick on_click
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SendMessageGoal(null);
    if (msg.text !== undefined) {
      resolved.text = msg.text;
    }
    else {
      resolved.text = ''
    }

    if (msg.cards !== undefined) {
      resolved.cards = new Array(msg.cards.length);
      for (let i = 0; i < resolved.cards.length; ++i) {
        resolved.cards[i] = Card.Resolve(msg.cards[i]);
      }
    }
    else {
      resolved.cards = []
    }

    if (msg.update_message !== undefined) {
      resolved.update_message = msg.update_message;
    }
    else {
      resolved.update_message = false
    }

    if (msg.thread_name !== undefined) {
      resolved.thread_name = msg.thread_name;
    }
    else {
      resolved.thread_name = ''
    }

    if (msg.space !== undefined) {
      resolved.space = msg.space;
    }
    else {
      resolved.space = ''
    }

    return resolved;
    }
};

module.exports = SendMessageGoal;
