// Auto-generated. Do not edit!

// (in-package google_chat_ros.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Message = require('./Message.js');
let Card = require('./Card.js');

//-----------------------------------------------------------

class SendMessageResult {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.message_result = null;
      this.cards_result = null;
      this.done = null;
    }
    else {
      if (initObj.hasOwnProperty('message_result')) {
        this.message_result = initObj.message_result
      }
      else {
        this.message_result = new Message();
      }
      if (initObj.hasOwnProperty('cards_result')) {
        this.cards_result = initObj.cards_result
      }
      else {
        this.cards_result = [];
      }
      if (initObj.hasOwnProperty('done')) {
        this.done = initObj.done
      }
      else {
        this.done = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SendMessageResult
    // Serialize message field [message_result]
    bufferOffset = Message.serialize(obj.message_result, buffer, bufferOffset);
    // Serialize message field [cards_result]
    // Serialize the length for message field [cards_result]
    bufferOffset = _serializer.uint32(obj.cards_result.length, buffer, bufferOffset);
    obj.cards_result.forEach((val) => {
      bufferOffset = Card.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [done]
    bufferOffset = _serializer.bool(obj.done, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SendMessageResult
    let len;
    let data = new SendMessageResult(null);
    // Deserialize message field [message_result]
    data.message_result = Message.deserialize(buffer, bufferOffset);
    // Deserialize message field [cards_result]
    // Deserialize array length for message field [cards_result]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.cards_result = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.cards_result[i] = Card.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [done]
    data.done = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += Message.getMessageSize(object.message_result);
    object.cards_result.forEach((val) => {
      length += Card.getMessageSize(val);
    });
    return length + 5;
  }

  static datatype() {
    // Returns string type for a message object
    return 'google_chat_ros/SendMessageResult';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '2debf2fb1ec68366c318ee077fe23b31';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    # Define the result
    google_chat_ros/Message message_result
    google_chat_ros/Card[] cards_result
    bool done
    
    ================================================================================
    MSG: google_chat_ros/Message
    string name # Resource name in form spaces/*/messages/*
    google_chat_ros/User sender # The user who created the message
    string create_time # The time at which the message was created in Google Chat server
    string text # Plain-text body of the message
    string thread_name # The thread the message belongs to
    google_chat_ros/Annotation[] annotations # Annotations associated with the plain-text body of the message
    string argument_text # Plain-text body of the message with all bot mentions stripped out
    google_chat_ros/Attachment[] attachments # User uploaded attachment
    
    ================================================================================
    MSG: google_chat_ros/User
    string name
    string display_name
    string avatar_url
    uint8[] avatar
    string email
    bool bot
    bool human
    
    ================================================================================
    MSG: google_chat_ros/Annotation
    int32 length
    int32 start_index
    google_chat_ros/User user
    ## START AnnotationType ##
    bool mention
    bool slash_command
    ### END AnnotationType ###
    google_chat_ros/SlashCommand command
    
    ================================================================================
    MSG: google_chat_ros/SlashCommand
    google_chat_ros/User user
    bool added
    bool invoke
    string command_name
    string command_id
    bool triggers_dialog
    
    ================================================================================
    MSG: google_chat_ros/Attachment
    string name
    string content_name
    string content_type
    string thumnail_uri
    string download_uri
    string localpath
    bool drive_file
    bool uploaded_content
    string attachment_resource_name
    string drive_field_id
    
    ================================================================================
    MSG: google_chat_ros/Card
    google_chat_ros/CardHeader header # The header of the card
    google_chat_ros/Section[] sections # Sections are separated by a line divider
    google_chat_ros/CardAction[] card_actions # The actions of this card
    string name # Name of the card
    
    ================================================================================
    MSG: google_chat_ros/CardHeader
    string title
    string subtitle
    bool image_style_circular # The image's type, makes border
    string image_url
    string image_filepath # The image in the card header
    
    ================================================================================
    MSG: google_chat_ros/Section
    string header # The header of the section
    google_chat_ros/WidgetMarkup[] widgets
    
    ================================================================================
    MSG: google_chat_ros/WidgetMarkup
    google_chat_ros/Button[] buttons
    string text_paragraph # Display a text paragraph in this widget
    google_chat_ros/Image image # Display an image in this widget
    google_chat_ros/KeyValue key_value # Display a key value item in this widget
    
    ================================================================================
    MSG: google_chat_ros/Button
    ### FIELD DATA CAN BE ONLY ONE OF THE TEXT BUTTON OR IMAGE BUTTON ###
    # A button with text and onclick action
    string text_button_name 
    google_chat_ros/OnClick text_button_on_click
    # An image button with an onclick action
    string image_button_name
    google_chat_ros/OnClick image_button_on_click
    string icon # see https://developers.google.com/chat/api/reference/rest/v1/cards#icon
    string original_icon_url # Original icon image's url
    string original_icon_filepath # Original icon
    
    ================================================================================
    MSG: google_chat_ros/OnClick
    ### FIELD DATA CAN BE ONLY ONE OF THE FOLLOWING ###
    google_chat_ros/FormAction action # A form action will be triggered by this onclick if specified
    string open_link_url # A link that opens a new window
    
    ================================================================================
    MSG: google_chat_ros/FormAction
    # The form action data associated with an interactive card that was clicked. Only populated for CARD_CLICKED events.
    string action_method_name
    google_chat_ros/ActionParameter[] parameters
    
    ================================================================================
    MSG: google_chat_ros/ActionParameter
    string key
    string value
    
    ================================================================================
    MSG: google_chat_ros/Image
    string image_url
    string localpath # If you want to upload new image on google drive, please set this element, not image_uri.
    google_chat_ros/OnClick on_click
    float64 aspect_ratio # The aspect ratio of this image (width/height). If unset, the server fills it by prefetching the image
    
    ================================================================================
    MSG: google_chat_ros/KeyValue
    string top_label # The text of the top label
    string content # The text of the content. Always required
    bool content_multiline # If the content should be multiline
    string bottom_label # The text of the bottom label
    google_chat_ros/OnClick on_click
    string icon # see https://developers.google.com/chat/api/reference/rest/v1/cards#icon
    string original_icon_url # Original icon image's url
    string original_icon_localpath # If you want to upload new image on google drive, please set this element, not original_icon_url.
    google_chat_ros/Button button # A button that can be clicked to trigger an action
    
    ================================================================================
    MSG: google_chat_ros/CardAction
    string action_label # The label used to be displayed in the action menu item
    google_chat_ros/OnClick on_click
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SendMessageResult(null);
    if (msg.message_result !== undefined) {
      resolved.message_result = Message.Resolve(msg.message_result)
    }
    else {
      resolved.message_result = new Message()
    }

    if (msg.cards_result !== undefined) {
      resolved.cards_result = new Array(msg.cards_result.length);
      for (let i = 0; i < resolved.cards_result.length; ++i) {
        resolved.cards_result[i] = Card.Resolve(msg.cards_result[i]);
      }
    }
    else {
      resolved.cards_result = []
    }

    if (msg.done !== undefined) {
      resolved.done = msg.done;
    }
    else {
      resolved.done = false
    }

    return resolved;
    }
};

module.exports = SendMessageResult;
